#include <iostream>
#include <vector>
#include <fstream>
#include "cmath"
#include "algorithm"


using namespace std;

#define int long long
#define double long double


bool check(const string &s) {
    int c = 0;
    for (char i: s) {
        if (i == '(') c++;
        else c--;
        if (c < 0) return false;
    }
    return c == 0;
}

bool check_k(const string &s) {
    int opened = 0;
    int closed = 0;
    for (char i: s) {
        if (i == '(') opened++;
        else closed++;
    }
    return closed == opened;
}

int getMinIndex(const string &s) {
    int c = 0;
    int min_c = LLONG_MAX;
    int min_ind = 0;

    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == '(') c++;
        else c--;

        if (c < min_c) {
            min_c = c;
            min_ind = i;
        }
    }
    return min_ind;
}

signed main() {

    string s;
    cin >> s;
    if(check(s)){
        cout<<"YES";
        return 0;
    }
    if (!check_k(s)) {
        cout << "NO";
        return 0;
    }

    int minIndex = getMinIndex(s);


#pragma omp parallel for

    for (int i = minIndex; i < s.size(); ++i) {
        string new_s = s.substr(i, s.size()) + s.substr(0, i);
        if (check(new_s)) {
            cout << "YES" << endl;
            return 0;
        }
    }
    cout << "NO" << endl;
    return 0;

}